/* wrapper.c - a C wrapper program that, when suid, can
 * run shell scripts as another user.
 * Written 6/2010 by Wayne Pollock, Tampa Florida USA
 */

#define _XOPEN_SOURCE 500

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main ( int argc, char* argv[]  )
{
    char cmd[255] = "bash -c \"";

    /* Set default command if no args: */
    if ( argc == 1 )
      strncat( cmd, "cat secret.txt", sizeof( cmd ) );
    else /* Build command line to pass to bash: */
    for ( int i = 1; i < argc; ++i )
    {
       strncat( cmd, " ", sizeof( cmd ) );
       strncat( cmd, argv[i], sizeof( cmd ) );
    }

    /* Terminate command: */
    strncat( cmd, "\"", sizeof( cmd ) );

    /* Set the real and effective UID to the current effective UID: */
    setreuid( geteuid(),  geteuid() );
    return system( cmd );
}
